// Smolenov Oscilator

seed;
time 0;
stop_time 50000;
readout_interval 10;
output_file ./Oscilator/temp.txt;
save_interval;

lua !{
	ln2 = 0.693147;
	mRNA_delay = 40;
	mRNA_deg = ln2/2/60;
	mRNA_trans = 0.1;
	nic_deg = 0.0005;
	rnap_deg = 0.005;
	gfp_deg = 0.0005;
	rnap_speed = 200;
	nictal_bound = 0.031;
	nictal_unbound = 0.0002;
	rnapt7_bound = 50;
	rnapt7_unbound = 0.2;
	rnap_cmv = 0.01;
}!

population {

	pT7_rnapt7 = 1;
	pT7_gfp = 5000;
	pT7_nictal = 500;
	pCMV = 1;
	pT7_rnapt7a = 0;
	pT7_rnapt7r = 0;
	pT7_nictala = 0;
	pT7_nictalr = 0;
	pT7_gfpa = 0;
	pT7_gfpr = 0;
	RNAPT7 = 0;
	NICTAL = 0;
	GFP = 0;

	mRNA_rnapt7 = 0;
	mRNA_nictal = 0;
	mRNA_gfp = 0;
}

reaction {
	
	pT7_rnapt7 + RNAPT7 --[rnapt7_bound]--> pT7_rnapt7a;
	pT7_rnapt7a --[rnapt7_unbound]--> pT7_rnapt7 + RNAPT7;
	pT7_rnapt7 + NICTAL --[nictal_bound]--> pT7_rnapt7r;
	pT7_rnapt7r --[nictal_unbound]--> pT7_rnapt7 + NICTAL;
	pT7_rnapt7r --[nic_deg]--> pT7_rnapt7;
	pT7_rnapt7a --[rnap_speed/2600]--> mRNA_rnapt7(2600/rnap_speed) + pT7_rnapt7(2600/rnap_speed) + RNAPT7(2600/rnap_speed);
	mRNA_rnapt7 --[mRNA_trans]--> RNAPT7(exp:1/(mRNA_delay)) + mRNA_rnapt7(mRNA_delay);
	mRNA_rnapt7 --[mRNA_deg]--> ;
	RNAPT7 --[rnap_deg]--> ;

	pT7_nictal + RNAPT7 --[rnapt7_bound]--> pT7_nictala;
	pT7_nictala --[rnapt7_unbound]--> pT7_nictal + RNAPT7;
	pT7_nictal + NICTAL --[nictal_bound]--> pT7_nictalr;
	pT7_nictalr --[nictal_unbound]--> pT7_nictal + NICTAL;
	pT7_nictalr --[nic_deg]--> pT7_nictal;
	pT7_nictala --[rnap_speed/1700]--> mRNA_nictal(1700/rnap_speed) + pT7_nictal(1700/rnap_speed) + RNAPT7(1700/rnap_speed);
	mRNA_nictal --[mRNA_trans]--> NICTAL(exp:1/(mRNA_delay)) + mRNA_nictal(mRNA_delay);
	mRNA_nictal --[mRNA_deg]--> ;
	NICTAL --[nic_deg]--> ;

	pT7_gfp + RNAPT7 --[rnapt7_bound]--> pT7_gfpa;
	pT7_gfpa --[rnapt7_unbound]--> pT7_gfp + RNAPT7;
	pT7_gfp + NICTAL --[nictal_bound]--> pT7_gfpr;
	pT7_gfpr --[nictal_unbound]--> pT7_gfp + NICTAL;
	pT7_gfpr --[nic_deg]--> pT7_gfp;
	pT7_gfpa --[rnap_speed/700]--> mRNA_gfp(700/rnap_speed) + pT7_gfp(700/rnap_speed) + RNAPT7(700/rnap_speed);
	mRNA_gfp --[mRNA_trans]--> GFP(exp:1/(mRNA_delay)) + mRNA_gfp(mRNA_delay);
	mRNA_gfp --[mRNA_deg]--> ;
	GFP --[gfp_deg]--> ;

	pCMV --[rnap_cmv]--> RNAPT7 + pCMV;
}

save_now oscillator.dat;
